package vc.thinker.mqtt.proxyclient.actor.down;

import akka.actor.AbstractActor;
import akka.japi.pf.ReceiveBuilder;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;
import vc.thinker.absctacts.mqtt.entity.MqttResponse;
import vc.thinker.mqtt.proxyclient.entity.down.MeterListResponse;
import vc.thinker.mqtt.proxyclient.service.ThirdPartyProxyClientService;

import javax.annotation.Resource;

/**
 * 仪表列表拉取响应
 *
 * @author HeTongHao
 * @since 2022/18/19 15:43
 */
@Slf4j
@Component
@Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class MeterListPullResponseActor extends AbstractActor {
    @Resource
    private ThirdPartyProxyClientService thirdPartyProxyClientService;

    public MeterListPullResponseActor() {
        receive(ReceiveBuilder.match(MqttResponse.class, mqttResponse -> {
            MeterListResponse meterListResponse = JSONObject.parseObject(mqttResponse.getMessage(), MeterListResponse.class);
            // 响应数据
            thirdPartyProxyClientService.responseData(meterListResponse.getRequestId(), meterListResponse.getMeterList());
        }).build());
    }
}
